diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
similarity index 99%
rename from src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
rename to game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
index f0bed94c0..fbb60f1e0 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
@@ -14,7 +14,7 @@ import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.net.packet.BlockEntityDataPacket;
+import net.minecraft.core.net.packet.PacketBlockEntityData;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.Side;
@@ -371,7 +371,7 @@ public class TileEntityFurnace extends TileEntity
 
     @Override
     public Packet getDescriptionPacket() {
-        return new BlockEntityDataPacket(this);
+        return new PacketBlockEntityData(this);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java
similarity index 93%
rename from src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java
rename to game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java
index 2dac646f2..001f3f73c 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block.entity;
 
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.LevelListener;
@@ -19,9 +19,9 @@ public class TileEntityJukebox extends TileEntity {
         record = nbttagcompound.getInteger("Record");
         byte expanded = nbttagcompound.getByte("Expanded");
         if (expanded == 0 && record >= 256) {
-            record += (Block.blocksList.length - 256);
+            record += (Blocks.blocksList.length - 256);
         }
-        if (record < Block.blocksList.length) {
+        if (record < Blocks.blocksList.length) {
             short[] id = new short[]{(short) record};
             byte[] meta = new byte[]{(byte) 0};
             ChunkConverter.converters[0].convertBlocksAndMetadata(id, meta);
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
similarity index 95%
rename from src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
rename to game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
index 4a072ba6d..59703abee 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
@@ -5,7 +5,7 @@ import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.BlockEntityDataPacket;
+import net.minecraft.core.net.packet.PacketBlockEntityData;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
@@ -79,6 +79,6 @@ public class TileEntityMeshGold extends TileEntity {
 
     @Override
     public Packet getDescriptionPacket() {
-        return new BlockEntityDataPacket(this);
+        return new PacketBlockEntityData(this);
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
similarity index 95%
rename from src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
rename to game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
index aeaebe6df..4f3e6649a 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
@@ -3,17 +3,13 @@ package net.minecraft.core.block.entity;
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.entity.Mob;
-import net.minecraft.core.enums.MobCategory;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.phys.AABB;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.SetMobSpawnerPacket;
-import net.minecraft.core.entity.SpawnListEntry;
+import net.minecraft.core.net.packet.PacketSetMobSpawner;
 import org.slf4j.Logger;
 
-import java.util.List;
-
 public class TileEntityMobSpawner extends TileEntity
 {
     private static final Logger LOGGER = LogUtils.getLogger();
@@ -142,7 +138,7 @@ public class TileEntityMobSpawner extends TileEntity
     @Override
 	public Packet getDescriptionPacket()
     {
-        return new SetMobSpawnerPacket(x, y, z, EntityDispatcher.classForId(mobId));
+        return new PacketSetMobSpawner(x, y, z, EntityDispatcher.classForId(mobId));
     }
     
     public int countNearbySpawners() {
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
similarity index 98%
rename from src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
rename to game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
index 9152d4e2c..2485e6d0f 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
@@ -150,6 +150,6 @@ public class TileEntitySeat
     public void readFromNBT(CompoundTag compoundTag)
     {
         super.readFromNBT(compoundTag);
-        seat = Block.getBlock(compoundTag.getIntegerOrDefault("Block", Blocks.SEAT.id));
+        seat = Blocks.getBlock(compoundTag.getIntegerOrDefault("Block", Blocks.SEAT.id));
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
similarity index 98%
rename from src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
rename to game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
index 88e5f0514..39a23e871 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
@@ -33,7 +33,7 @@ public class TileEntitySensor extends TileEntity {
 			int y1 = MathHelper.round(y + facing.getOffsetY() * i);
 			int z1 = MathHelper.round(z + facing.getOffsetZ() * i);
 			int id = world.getBlockId(x1, y1, z1);
-			if(Block.solid[id] && !Block.hasTag(id, BlockTags.EXTENDS_MOTION_SENSOR_RANGE)) {
+			if(Blocks.solid[id] && !Block.hasTag(id, BlockTags.EXTENDS_MOTION_SENSOR_RANGE)) {
 				return i - 1;
 			}
 		}
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
similarity index 96%
rename from src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
rename to game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
index 033b6e71e..c73f70ef3 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
@@ -5,7 +5,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumSignPicture;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.BlockEntityDataPacket;
+import net.minecraft.core.net.packet.PacketBlockEntityData;
 import net.minecraft.core.util.helper.UUIDHelper;
 import org.jetbrains.annotations.Nullable;
 
@@ -124,7 +124,7 @@ public class TileEntitySign extends TileEntity
     @Override
 	public Packet getDescriptionPacket()
     {
-        return new BlockEntityDataPacket(this);
+        return new PacketBlockEntityData(this);
     }
 
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
similarity index 99%
rename from src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
rename to game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
index fee933a60..aee215574 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
@@ -291,7 +291,7 @@ public class TileEntityTrommel extends TileEntity
         	int adjacentId = worldObj != null ? worldObj.getBlockId(x + xOffset, y, z + zOffset) : 0;
         	
         	Container chest = null;
-        	if (Block.blocksList[adjacentId] instanceof BlockChest) {
+        	if (Blocks.blocksList[adjacentId] instanceof BlockChest) {
                 assert worldObj != null;
                 chest = BlockChest.getInventory(worldObj, x + xOffset, y, z + zOffset);
         	}
diff --git a/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java b/game/core/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java
similarity index 98%
rename from src/main/java/net/minecraft/core/block/motion/CarriedBlock.java
rename to game/core/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java
index 9764603a4..05af9554c 100644
--- a/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java
@@ -2,6 +2,7 @@ package net.minecraft.core.block.motion;
 
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityDispatcher;
 import net.minecraft.core.block.tag.BlockTags;
@@ -42,7 +43,7 @@ public class CarriedBlock implements ICarriable {
     }
 
     public Block block() {
-        return Block.getBlock(blockId);
+        return Blocks.getBlock(blockId);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/piston/BlockPistonBase.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonBase.java
similarity index 90%
rename from src/main/java/net/minecraft/core/block/piston/BlockPistonBase.java
rename to game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonBase.java
index 9a5d59bb6..8bf4f9f0d 100644
--- a/src/main/java/net/minecraft/core/block/piston/BlockPistonBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonBase.java
@@ -182,7 +182,7 @@ public class BlockPistonBase extends Block
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
         int data = world.getBlockMetadata(x, y, z);
         if(isPowered(data))
@@ -190,35 +190,24 @@ public class BlockPistonBase extends Block
             switch(getDirection(data))
             {
                 case DOWN:
-                setBlockBounds(0.0F, 0.25F, 0.0F, 1.0F, 1.0F, 1.0F);
-                break;
+                    return AABB.getTemporaryBB(0.0F, 0.25F, 0.0F, 1.0F, 1.0F, 1.0F);
                 case UP:
-                setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.75F, 1.0F);
-                break;
+                    return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 0.75F, 1.0F);
                 case NORTH:
-                setBlockBounds(0.0F, 0.0F, 0.25F, 1.0F, 1.0F, 1.0F);
-                break;
+                    return AABB.getTemporaryBB(0.0F, 0.0F, 0.25F, 1.0F, 1.0F, 1.0F);
                 case SOUTH:
-                setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.75F);
-                break;
+                    return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.75F);
                 case WEST:
-                setBlockBounds(0.25F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-                break;
+                    return AABB.getTemporaryBB(0.25F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
                 case EAST:
-                setBlockBounds(0.0F, 0.0F, 0.0F, 0.75F, 1.0F, 1.0F);
-                break;
+                default:
+                    return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 0.75F, 1.0F, 1.0F);
             }
         } else
         {
-            setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+            return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
         }
     }
-    @Override
-    public void getCollidingBoundingBoxes(World world, int x, int y, int z, AABB aabb, ArrayList<AABB> aabbs)
-    {
-        setBlockBoundsBasedOnState(world, x, y, z);
-        super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbs);
-    }
 
     @Override
 	public boolean isCubeShaped()
@@ -238,7 +227,7 @@ public class BlockPistonBase extends Block
     
     protected boolean isPushable(int id, World world, int x, int y, int z, boolean canDestroy)
     {
-        Block block = Block.getBlock(id);
+        Block block = Blocks.getBlock(id);
         if (block == null) return false;
         int pushReaction = block.getPistonPushReaction(world, x, y, z);
         if (block.hasTag(BlockTags.PISTON_CRUSHING) ||
@@ -277,12 +266,12 @@ public class BlockPistonBase extends Block
                 break;
             }
             if (!isPushable(id, world, xo, yo, zo, true)) {
-                if (blocks == 1 && BlockTags.PISTON_CRUSHING.appliesTo(Block.getBlock(id)) && tryCrush(world, x, y, z, direction)) {
+                if (blocks == 1 && BlockTags.PISTON_CRUSHING.appliesTo(Blocks.getBlock(id)) && tryCrush(world, x, y, z, direction)) {
                     break;
                 }
                 return false;
             }
-            if (Block.blocksList[id].getPistonPushReaction(world, xo, yo, zo) == Material.PISTON_DESTROY_ON_PUSH) {
+            if (Blocks.blocksList[id].getPistonPushReaction(world, xo, yo, zo) == Material.PISTON_DESTROY_ON_PUSH) {
                 break;
             }
             if (blocks == maxPushedBlocks) {
@@ -329,8 +318,8 @@ public class BlockPistonBase extends Block
             if (!isPushable(blockId, world, xo, yo, zo, true)) {
                 return false;
             }
-            if (Block.blocksList[blockId].getPistonPushReaction(world, xo, yo, zo) == Material.PISTON_DESTROY_ON_PUSH) {
-                Block.blocksList[blockId].dropBlockWithCause(world, EnumDropCause.WORLD, xo, yo, zo, world.getBlockMetadata(xo, yo, zo), world.getBlockEntity(xo, yo, zo), null);
+            if (Blocks.blocksList[blockId].getPistonPushReaction(world, xo, yo, zo) == Material.PISTON_DESTROY_ON_PUSH) {
+                Blocks.blocksList[blockId].dropBlockWithCause(world, EnumDropCause.WORLD, xo, yo, zo, world.getBlockMetadata(xo, yo, zo), world.getBlockEntity(xo, yo, zo), null);
                 break;
             }
             if (blocks == maxPushedBlocks) {
diff --git a/src/main/java/net/minecraft/core/block/piston/BlockPistonBaseSteel.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonBaseSteel.java
similarity index 85%
rename from src/main/java/net/minecraft/core/block/piston/BlockPistonBaseSteel.java
rename to game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonBaseSteel.java
index 5a7ac953a..b1db533be 100644
--- a/src/main/java/net/minecraft/core/block/piston/BlockPistonBaseSteel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonBaseSteel.java
@@ -28,7 +28,7 @@ public class BlockPistonBaseSteel extends BlockPistonBase {
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
         int data = world.getBlockMetadata(x, y, z);
         if(isPowered(data))
@@ -36,27 +36,22 @@ public class BlockPistonBaseSteel extends BlockPistonBase {
             switch(getDirection(data))
             {
                 case DOWN:
-                    setBlockBounds(0.0F, HEAD_THICKNESS_STEEL, 0.0F, 1.0F, 1.0F, 1.0F);
-                    break;
+                    return AABB.getTemporaryBB(0.0F, HEAD_THICKNESS_STEEL, 0.0F, 1.0F, 1.0F, 1.0F);
                 case UP:
-                    setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1 - HEAD_THICKNESS_STEEL, 1.0F);
-                    break;
+                    return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1 - HEAD_THICKNESS_STEEL, 1.0F);
                 case NORTH:
-                    setBlockBounds(0.0F, 0.0F, HEAD_THICKNESS_STEEL, 1.0F, 1.0F, 1.0F);
-                    break;
+                    return AABB.getTemporaryBB(0.0F, 0.0F, HEAD_THICKNESS_STEEL, 1.0F, 1.0F, 1.0F);
                 case SOUTH:
-                    setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1 - HEAD_THICKNESS_STEEL);
-                    break;
+                    return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1 - HEAD_THICKNESS_STEEL);
                 case WEST:
-                    setBlockBounds(HEAD_THICKNESS_STEEL, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-                    break;
+                    return AABB.getTemporaryBB(HEAD_THICKNESS_STEEL, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
                 case EAST:
-                    setBlockBounds(0.0F, 0.0F, 0.0F, 1 - HEAD_THICKNESS_STEEL, 1.0F, 1.0F);
-                    break;
+                default:
+                    return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1 - HEAD_THICKNESS_STEEL, 1.0F, 1.0F);
             }
         } else
         {
-            setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+            return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
         }
     }
 
@@ -80,13 +75,13 @@ public class BlockPistonBaseSteel extends BlockPistonBase {
                 break;
             }
             if (!isPushable(id, world, xo, yo, zo, true)) {
-                if (blocks == 1 && BlockTags.PISTON_CRUSHING.appliesTo(Block.getBlock(id)) && tryCrush(world, x, y, z, direction)) {
+                if (blocks == 1 && BlockTags.PISTON_CRUSHING.appliesTo(Blocks.getBlock(id)) && tryCrush(world, x, y, z, direction)) {
                     didCrush = true;
                     break;
                 }
                 return false;
             }
-            if (Block.blocksList[id].getPistonPushReaction(world, xo, yo, zo) == Material.PISTON_DESTROY_ON_PUSH) {
+            if (Blocks.blocksList[id].getPistonPushReaction(world, xo, yo, zo) == Material.PISTON_DESTROY_ON_PUSH) {
                 break;
             }
             if (blocks == maxPushedBlocks) {
diff --git a/src/main/java/net/minecraft/core/block/piston/BlockPistonBaseSticky.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonBaseSticky.java
similarity index 96%
rename from src/main/java/net/minecraft/core/block/piston/BlockPistonBaseSticky.java
rename to game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonBaseSticky.java
index de5268130..caf6c3129 100644
--- a/src/main/java/net/minecraft/core/block/piston/BlockPistonBaseSticky.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonBaseSticky.java
@@ -52,7 +52,7 @@ public class BlockPistonBaseSticky extends BlockPistonBase {
         }
         if(!pulledMoving && retractId > 0 &&
             isPushable(retractId, world, x1, y1, z1, false) &&
-            (Block.blocksList[retractId].getPistonPushReaction(world, x1, y1, z1) == Material.PISTON_PUSHABLE || (Block.getBlock(retractId) instanceof BlockPistonBase)))
+            (Blocks.blocksList[retractId].getPistonPushReaction(world, x1, y1, z1) == Material.PISTON_PUSHABLE || (Blocks.getBlock(retractId) instanceof BlockPistonBase)))
         {
             if (!(retractEntity instanceof TileEntityMovingPistonBlock)) {
                 world.removeBlockTileEntity(x1, y1, z1);
diff --git a/src/main/java/net/minecraft/core/block/piston/BlockPistonHead.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonHead.java
similarity index 57%
rename from src/main/java/net/minecraft/core/block/piston/BlockPistonHead.java
rename to game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonHead.java
index 1abe9c8c7..6a6ca3fe7 100644
--- a/src/main/java/net/minecraft/core/block/piston/BlockPistonHead.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonHead.java
@@ -81,84 +81,55 @@ public class BlockPistonHead extends Block
     @Override
     public void getCollidingBoundingBoxes(World world, int x, int y, int z, AABB aabb, ArrayList<AABB> aabbList)
     {
-        int l = world.getBlockMetadata(x, y, z);
-        switch(getDirectionFromMeta(l))
+        switch(getDirectionFromMeta(world.getBlockMetadata(x, y, z)))
         {
-            case DOWN: // '\0'
-            setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, headThickness, 1.0F);
-            super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-            setBlockBounds(0.375F, headThickness, 0.375F, 0.625F, 1 + headThickness, 0.625F);
-            super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-            break;
-
-            case UP: // '\001'
-            setBlockBounds(0.0F, 1 - headThickness, 0.0F, 1.0F, 1.0F, 1.0F);
-            super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-            setBlockBounds(0.375F, -headThickness, 0.375F, 0.625F, 1 - headThickness, 0.625F);
-            super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-            break;
-
-            case NORTH: // '\002'
-            setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, headThickness);
-            super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-            setBlockBounds(headThickness, 0.375F, headThickness, 1 - headThickness, 0.625F, 1 + headThickness);
-            super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-            break;
-
-            case SOUTH: // '\003'
-            setBlockBounds(0.0F, 0.0F, 1 - headThickness, 1.0F, 1.0F, 1.0F);
-            super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-            setBlockBounds(headThickness, 0.375F, -headThickness, 1 - headThickness, 0.625F, 1 - headThickness);
-            super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-            break;
-
-            case WEST: // '\004'
-            setBlockBounds(0.0F, 0.0F, 0.0F, headThickness, 1.0F, 1.0F);
-            super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-            setBlockBounds(headThickness, 0.375F, headThickness, 1 + headThickness, 0.625F, 1 - headThickness);
-            super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-            break;
-
-            case EAST: // '\005'
-            setBlockBounds(1 - headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-            super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-            setBlockBounds(-headThickness, 0.375F, headThickness, 1 - headThickness, 0.625F, 1 - headThickness);
-            super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-            break;
+            case DOWN:
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, headThickness, 1.0F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.375F, headThickness, 0.375F, 0.625F, 1 + headThickness, 0.625F).move(x, y, z), aabbList);
+                break;
+            case UP:
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 1 - headThickness, 0.0F, 1.0F, 1.0F, 1.0F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.375F, -headThickness, 0.375F, 0.625F, 1 - headThickness, 0.625F).move(x, y, z), aabbList);
+                break;
+            case NORTH:
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, headThickness).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(headThickness, 0.375F, headThickness, 1 - headThickness, 0.625F, 1 + headThickness).move(x, y, z), aabbList);
+                break;
+            case SOUTH:
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F, 1 - headThickness, 1.0F, 1.0F, 1.0F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(headThickness, 0.375F, -headThickness, 1 - headThickness, 0.625F, 1 - headThickness).move(x, y, z), aabbList);
+                break;
+            case WEST:
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, headThickness, 1.0F, 1.0F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(headThickness, 0.375F, headThickness, 1 + headThickness, 0.625F, 1 - headThickness).move(x, y, z), aabbList);
+                break;
+            case EAST:
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(1 - headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(-headThickness, 0.375F, headThickness, 1 - headThickness, 0.625F, 1 - headThickness).move(x, y, z), aabbList);
+                break;
         }
-        setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
         int l = world.getBlockMetadata(x, y, z);
         switch(getDirectionFromMeta(l))
         {
-            case DOWN: // '\0'
-            setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, headThickness, 1.0F);
-            break;
-
-            case UP: // '\001'
-            setBlockBounds(0.0F, 1 - headThickness, 0.0F, 1.0F, 1.0F, 1.0F);
-            break;
-
-            case NORTH: // '\002'
-            setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, headThickness);
-            break;
-
-            case SOUTH: // '\003'
-            setBlockBounds(0.0F, 0.0F, 1 - headThickness, 1.0F, 1.0F, 1.0F);
-            break;
-
-            case WEST: // '\004'
-            setBlockBounds(0.0F, 0.0F, 0.0F, headThickness, 1.0F, 1.0F);
-            break;
-
-            case EAST: // '\005'
-            setBlockBounds(1 - headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-            break;
+            case DOWN:
+                return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, headThickness, 1.0F);
+            case UP:
+                return AABB.getTemporaryBB(0.0F, 1 - headThickness, 0.0F, 1.0F, 1.0F, 1.0F);
+            case NORTH:
+                return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, headThickness);
+            case SOUTH:
+                return AABB.getTemporaryBB(0.0F, 0.0F, 1 - headThickness, 1.0F, 1.0F, 1.0F);
+            case WEST:
+                return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, headThickness, 1.0F, 1.0F);
+            case EAST:
+                return AABB.getTemporaryBB(1 - headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
         }
+        return super.getBlockBoundsFromState(world, x, y, z);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/piston/BlockPistonMoving.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonMoving.java
similarity index 85%
rename from src/main/java/net/minecraft/core/block/piston/BlockPistonMoving.java
rename to game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonMoving.java
index 9cf193d4b..8f2887ba2 100644
--- a/src/main/java/net/minecraft/core/block/piston/BlockPistonMoving.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonMoving.java
@@ -2,6 +2,7 @@ package net.minecraft.core.block.piston;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockTileEntity;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
@@ -102,7 +103,7 @@ public class BlockPistonMoving extends BlockTileEntity
         TileEntityMovingPistonBlock piston = getBlockEntity(world, x, y, z);
         if(piston != null)
         {
-            Block.blocksList[piston.getMovedId()].dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, meta, null, null);
+            Blocks.blocksList[piston.getMovedId()].dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, meta, null, null);
         }
     }
 
@@ -138,30 +139,32 @@ public class BlockPistonMoving extends BlockTileEntity
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
         TileEntityMovingPistonBlock pistonBlockEntity = getBlockEntity(world, x, y, z);
         if(pistonBlockEntity != null)
         {
-            Block block = Block.blocksList[pistonBlockEntity.getMovedId()];
+            Block block = Blocks.blocksList[pistonBlockEntity.getMovedId()];
             if(block == null || block == this)
             {
-                return;
+                return getBlockBoundsFromState(world, x, y, z);
             }
-            block.setBlockBoundsBasedOnState(world, x, y, z);
             float f = pistonBlockEntity.getProgress(0.0F);
             if(pistonBlockEntity.isExtending())
             {
                 f = 1.0F - f;
             }
             Direction direction = pistonBlockEntity.getDirection();
-            minX = block.minX - direction.getOffsetX() * f;
-            maxX = block.maxX - direction.getOffsetX() * f;
-            minY = block.minY - direction.getOffsetY() * f;
-            maxY = block.maxY - direction.getOffsetY() * f;
-            minZ = block.minZ - direction.getOffsetZ() * f;
-            maxZ = block.maxZ - direction.getOffsetZ() * f;
+            AABB otherBounds = block.getBlockBoundsFromState(world, x, y, z);
+            return AABB.getTemporaryBB(
+            otherBounds.minX - direction.getOffsetX() * f,
+            otherBounds.maxX - direction.getOffsetX() * f,
+            otherBounds.minY - direction.getOffsetY() * f,
+            otherBounds.maxY - direction.getOffsetY() * f,
+            otherBounds.minZ - direction.getOffsetZ() * f,
+            otherBounds.maxZ - direction.getOffsetZ() * f);
         }
+        return getBlockBoundsFromState(world, x, y, z);
     }
 
     public AABB getCollisionShapeFromTileEntity(WorldSource world, int x, int y, int z, int blockID, float directionStretch, Direction direction)
@@ -170,7 +173,7 @@ public class BlockPistonMoving extends BlockTileEntity
         {
             return null;
         }
-        AABB aabb = Block.blocksList[blockID].getCollisionBoundingBoxFromPool(world, x, y, z);
+        AABB aabb = Blocks.blocksList[blockID].getCollisionBoundingBoxFromPool(world, x, y, z);
         if(aabb == null)
         {
             return null;
